#!/bin/sh

if [ $# -ne 7 ] ; then
    echo "Usage : ${0} [PSQL-COMMAND] [IP] [PORT] [USERNAME] [IP0:PORT0] [IP1:PORT1] [USERDB]"
    exit 1
fi

PSQL=${1}
IP=${2}
PORT=${3}
USERNAME=${4}
URL0=${5}
URL1=${6}
USRDB=${7}
MNGDB="${USRDB}_pghainfo"

${PSQL} -h ${IP} -p ${PORT} -U ${USERNAME} -d template1 <<EOF
CREATE DATABASE ${MNGDB};
\c ${MNGDB}
BEGIN;
CREATE TABLE server_info (
    serverid smallint,
    udb_url text,
    udb_validity smallint
);
ALTER TABLE server_info ADD PRIMARY KEY (serverid);
CREATE TABLE global_config (
    mngdb_read_duration smallint,
    enable_sync_serverinfo boolean,
    mngcon_create_timeout smallint,
    mngquery_exec_timeout smallint,
    collect_runtimeinfo boolean,
    broken_error_prefix text,
    log_level smallint,
    log_formatter_name text,
    log_console_enable boolean,
    log_file_enable boolean,
    log_file_name text,
    log_file_size_mb smallint,
    log_file_rotate_count smallint
);
CREATE TABLE local_config (
    configid text,
    con_create_timeout smallint,
    query_exec_timeout smallint
);
ALTER TABLE local_config ADD PRIMARY KEY (configid);
CREATE TABLE broken_log_detail (
    serverid smallint,
    time timestamp,
    client text,
    api_task text,
    err_msg text,
    err_type text,
    err_state text,
    err_query text,
    err_stack text,
    app_thread text,
    app_stack text
);
CREATE VIEW broken_log as (
    SELECT
        serverid,
        time,
        client,
        api_task,
        err_msg,
        err_type,
        err_state,
        err_query
    FROM broken_log_detail
);
INSERT INTO server_info values (0, '${URL0}/${USRDB}', 1);
INSERT INTO server_info values (1, '${URL1}/${USRDB}', 1);
INSERT INTO global_config values (10, true, 10, 10, true, '08,53,57P,3D', 2, 'org.postgresforest.util.ForestFormatter', true, false, '/var/log/forest.log.%u-%g', 10, 5);
INSERT INTO local_config values ('DEFAULT', 10, 600);
COMMIT;
EOF